-- ball that rotate and shot!

enemyBall = {}

enemyBall.load = function(callback)
  ballImg = love.graphics.newImage("img/ballEnemy.png") --sprite of the enemy
  ball = {x = gameWidth, y = gameHeight / 2 - (250*gameScale) / 2, width= 250 * gameScale, height = 250 * gameScale,
  speed = 100, health = 8, angle = 0}
  ballEnemies = {} -- array for the enemies
  isDead = false --dead or not, so we can spawn a new one

  ballSpawnTime = math.random(5, 10) --time to create a new enemy
end

enemyBall.update = function(dt)
  ballSpawnTime = ballSpawnTime - dt

  ball.x = ball.x - ball.speed * dt -- movement
  ball.angle = ball.angle + math.pi * 0.02 -- rotation

  if ball.x < gameWidth - ball.width * 1.5 then --stop movement when reach X point
    ball.speed = 0
  end

  if spawnTime < 0.1 then -- X second passed, can spawn a new enemy
    isDead = false
    ballSpawnTime = math.random(5, 10) --assign new time to spawn
  end

  if ball.health < 1 then --kill the ball!
    isDead = true
  end

  for i, bull in ipairs(bullets) do --collision with the bullets!
    if overlap(bull.x, bull.y, bull.width, bull.height, ball.x, ball.y, ball.width - 10, ball.height - 10) then
      ball.health = ball.health - 1
      table.remove(bullets, i)
    end
  end

  if isDead == true then --reset the ball
    ball.health = 8
    ball.x = gameWidth + 500
    ball.y = -500
    ball.speed = 100
    isDead = false
  end

  if ball.x < gameWidth + 5 then
    ball.y = gameHeight / 2 - (250*gameScale) / 2
  end
end

enemyBall.draw = function(callback)
  love.graphics.draw(ballImg, ball.x, ball.y, ball.angle, gameScale, gameScale, ball.width / 2, ball.height / 2)
end

return enemyBall
