-- first kind of enemy, with a sine wave movement

enemyNormal = {}

enemyNormal.load = function(callback)
  normalEnemyImg = love.graphics.newImage("img/enemy2.png") --sprite of the enemy
  normalEnemy = {x = gameWidth, y = 0, width = 120 * gameScale, height = 120 * gameScale,
  speed = 550, health = 2}
  normalEnemies = {} -- array for the normal enemies

  normalEnemyTimer = 2
  normalEnemySpawn = false
end

enemyNormal.update = function(dt)
  normalEnemyTimer = normalEnemyTimer - dt

  if normalEnemyTimer < 0.1 then -- X second passed, can spawn new enemies
    normalEnemySpawn = true
    normalEnemyTimer = math.random(0.5, 1.5)
  end

  if normalEnemySpawn == true then -- create new enemy
      table.insert(normalEnemies, {health = 2, x = gameWidth + 10, y = math.random(0, gameHeight - 100),
      width = 120 * gameScale, height = 120 * gameScale })
      normalEnemySpawn = false
  end

  for i, enemy in ipairs(normalEnemies) do --movement of the ships
    enemy.x = enemy.x - (normalEnemy.speed * dt)
  end

  for i, enemy in ipairs(normalEnemies) do
    if enemy.x <= -80 then
      table.remove(normalEnemies, i) -- delete enemies when left screen
    end
    if enemy.health < 1 then
      table.remove(normalEnemies, i)-- delete enemies when hp is 0
    end
  end

  for i, bull in ipairs(bullets) do -- collisions with bullets and normal enemies
      for j, enemy in ipairs(normalEnemies) do
        if overlap(bull.x, bull.y, bull.width, bull.height, enemy.x, enemy.y, enemy.width, enemy.height) then
          enemy.health = enemy.health - 1
          table.remove(bullets, i) --remove bullet
          explosionSound:play() -- hit sound
          score = score + 10 --add score
        end
      end
  end
end

enemyNormal.draw = function(callback)
  for i, enemy in ipairs(normalEnemies) do
    love.graphics.draw(normalEnemyImg , enemy.x, enemy.y, 0, gameScale, gameScale) --draw enemies
  end
end

return enemyNormal
