-- first kind of enemy, with a sine wave movement

enemyWave = {}

enemyWave.load = function(callback)
  waveImg = love.graphics.newImage("img/enemy.png") --sprite of the enemy
  wave = {x = gameWidth, y= 0, width=120 *gameScale, height = 120 * gameScale,
  speed = 550, period = 1, pi = 3.1416, health = 1}
  countEnemy = 0
  enemies = {} -- array for the enemies
  canSpawn = false

  spawnTime = 3 --time to create a new wave
  spaceTime = 0 --time to create a new enemy in the wave, the space between them
end

enemyWave.update = function(dt)
  spawnTime = spawnTime - dt
  spaceTime = spaceTime + dt

  if spawnTime < 0.1 then -- X second passed, can spawn new enemies
    canSpawn = true
    spawnTime = math.random(2, 8)
  end

  if canSpawn == true then -- create new enemies
    if spaceTime > 0.2 then --space between enemies and add them
      table.insert(enemies, {health = 1 + 1,x = gameWidth +10, y = 50, width=120 *gameScale, height = 120 * gameScale})
      table.insert(enemies, {health = 1 + 1, x = gameWidth +10, y = gameHeight - 300,
      width=120 *gameScale, height = 120 * gameScale })
      spaceTime = 0 --reset the space
      countEnemy = countEnemy + 2
    end

    if countEnemy == 10 then --if enemies are 10, stop creating more
      canSpawn = false
      countEnemy = 0
    end
  end

  for i, enemy in ipairs(enemies) do --movement of the ships
    enemy.x = enemy.x - (wave.speed * dt)
    enemy.y = enemy.y + 8 * math.sin( enemy.x * wave.period * wave.pi / 180) --sine wave
  end

  for i, enemy in ipairs(enemies) do
    if enemy.x <= -50 then
      table.remove(enemies, i) -- delete enemies when left screen
    end
    if enemy.health < 1 then
      table.remove(enemies, i) -- delete enemies when hp is 0
    end
  end

  for i, bull in ipairs(bullets) do --collisions with bullets and enemyWaves
      for j, enemy in ipairs(enemies) do
        if overlap(bull.x, bull.y, bull.width, bull.height, enemy.x, enemy.y, enemy.width, enemy.height) then
          enemy.health = enemy.health - 1
          table.remove(bullets, i) --remove bullet
          explosionSound:play() -- hit sound
          score = score + 5 -- add score
        end
      end
  end
end

enemyWave.draw = function(callback)
  for i, enemy in ipairs(enemies) do
    love.graphics.draw(waveImg,enemy.x, enemy.y, 0, gameScale, gameScale) --draw enemy
  end
end

return enemyWave
