-- Game screen, all the logic goes here

game = {}

game.load = function(callback)
  ship1 = love.graphics.newImage("img/nave1.png") --ship 1
  player1 = {x= 25, y= gameHeight/2, width= 120 *gameScale, height= 120* gameScale, lives = 3}
  playerSpeed = 400

  score = 0

  playerBullet = love.graphics.newImage("img/bullet.png") -- normal bullet
  bullets = {}
  bulletTimer = 0
  bulletSpeed = 600

  -- all the sounds for the game screen
  explosionSound = love.audio.newSource("img/explosion.wav")
  shotSound = love.audio.newSource("img/pium.wav")
end

game.update = function(dt)
    love.graphics.setBackgroundColor( 0, 0, 0) -- black background
    love.graphics.setColor(255, 255, 255, 255) -- set the global color again to white

    if love.keyboard.isDown("escape") then -- exit te game, quick access for testing
      love.event.quit()
    end

    --Shot bullets if the bullet timer is > X
    bulletTimer = bulletTimer + dt
    if bulletTimer > 0.25 then
      if love.keyboard.isDown("kp4") then -- numpad number 4 for shot
        table.insert(bullets,{x = player1.x + 120*gameScale, y= player1.y + player1.height / 2,
        width = 43 * gameScale, height = 43 * gameScale})
        shotSound:play()
      end
      bulletTimer = 0
    end

    for i, v in ipairs(bullets) do --update the position of the bullets
      v.x = v.x + (bulletSpeed * dt)
      if v.x > gameWidth then
        table.remove(bullets, i)
      end
    end

    -- PLAYER 1 ------------------------------------------------------>
    if love.keyboard.isDown("w") then -- Movement of the player 1
      player1.y = player1.y - (playerSpeed * dt)
    end
    if love.keyboard.isDown("s") then
      player1.y = player1.y + (playerSpeed * dt)
    end
    if love.keyboard.isDown("d") then
      player1.x = player1.x + (playerSpeed * dt)
    end
    if love.keyboard.isDown("a") then
      player1.x = player1.x - (playerSpeed * dt)
    end

    if player1.x > gameWidth - 120 * gameScale then --colllision with the borders
      player1.x = gameWidth - 120 * gameScale
    end
    if player1.x < 0 then
      player1.x = 0
    end
    if player1.y > gameHeight - 120 * gameScale then
      player1.y = gameHeight - 120 * gameScale
    end
    if player1.y < 0 then
      player1.y = 0
    end
end

game.draw = function(callback)
  love.graphics.draw(ship1, player1.x, player1.y, 0, gameScale, gameScale)

  for i, v in ipairs(bullets) do
    love.graphics.draw(playerBullet, v.x, v.y, 0, gameScale, gameScale)
  end

  -- GUI
  fontGUI = love.graphics.setNewFont("img/pixel.ttf", 50 * gameScale) --font type
  love.graphics.setColor(255, 255, 255, 255) --color of the font
  love.graphics.print("Score " .. score, 200, 10) --text and position
end

return game
