-- Game by Sefhi & HJ ----------------------->
function love.load()
	love.mouse.setVisible (false) -- disable the mouse
	gameState = 1 -- 0 splash screen, 1 menu, 2 game, 3 scores
	gameTime = 1 --change from 0 to 1, 0 means the game is paused, 1 the game is running
  gameWidth = 1280
  gameHeight = 720
	--gameWidth = 1920
	--gameHeight = 1080
  gameScale = 0.5

  -- Main lua files for the different screens
  local splash = require"splash"
  local game = require"game"
  local menu = require"menu"
  local over = require"gameover"

  -- Enemies
  local enemyWave = require"enemyWave"
  --local enemyBall = require"enemyBall"
  local enemyNormal = require"enemyNormal"

	splash.load()
  game.load()
  menu.load()
  over.load()

  enemyWave.load()
  --enemyBall.load()
  enemyNormal.load()
end

function love.update(dt)
	if gameState == 0 then -- Splash screen, mango and dat stuff
    splash.update(dt)
	end
	if gameState == 1 then --Menu screen, simple animation, buttons and show the highscore
    menu.update(dt)
	end
	if gameState == 2 then --Game screen, all the logic goes here
    game.update(dt)

    enemyWave.update(dt)
    --enemyBall.update(dt)
    enemyNormal.update(dt)
	end
	if gameState == 3 then -- Game over or beat the game, show the score
    gameover.update(dt)
	end
end

function love.draw()
	if gameState == 0 then -- Splash screen, mango logo and powered by Love2D
		splash.draw()
	end
	if gameState == 1 then --Menu screen
    menu.draw()
	end
	if gameState == 2 then --Game screen
    game.draw()

    enemyWave.draw()
    --enemyBall.draw()
    enemyNormal.draw()
	end
	if gameState == 3 then -- Game over or beat the game
    gameover.draw()
	end
end

-- FUNCTIONS -------------------------->

--Function for collisions
function overlap(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end
