-- Splash screen, draw update and load functions

splash = {}

splash.load = function(callback)
  timerFade = 0
  red = 129 -- RGB colors & white for the font color
  green = 185
  blue = 78
  white = 255
end

splash.update = function(dt)
  timerFade = timerFade + dt -- use the timerFade as timer, adding each second 1

  if timerFade > 0.0002 then -- when the timer is greater than 0.02, add 1 to each color of RGB
    if white > 0 then
      white = white - 1
    end
    if red > 0 then
      red = red - 1
    end
    if green > 0 then
      green = green - 1
    end
    if blue > 0 then
      blue = blue - 1
    end
    timerFade = 0 --reset the timer
  end

  love.graphics.setBackgroundColor( white, white, white)
  love.graphics.setColor(red, green, blue, 255)

  if white < 1 then --blue is the smallest one so i use it to know when stop the fade and go to the menu
    love.timer.sleep ( 2 ) -- wait 2 seconds to read our AWESOME company name
    gameState = 1 -- go to the menu screen
  end
end

splash.draw = function(callback)
  fontSplash = love.graphics.setNewFont("img/FruitSale.ttf", 82)
  love.graphics.print("MELON MILKSHAKE", gameWidth / 2 - 250, gameHeight / 2 - 85)
  fontSplash = love.graphics.setNewFont("img/FruitSale.ttf", 34)
  love.graphics.print("presents", gameWidth / 2 - 75, gameHeight / 2 - 20)
end

return splash
